<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="时段" name="timePeriod">
        <a-input
          allow-clear
          placeholder="请输入时段"
          v-model:value="form.timePeriod"
        />
      </a-form-item>
      <a-form-item label="价格" name="price">
        <a-input
          allow-clear
          placeholder="请输入价格"
          v-model:value="form.price"
        />
      </a-form-item>
      <a-form-item label="每日不同价格" name="prices">
        <a-input
          allow-clear
          placeholder="请输入每日不同价格"
          v-model:value="form.prices"
        />
      </a-form-item>
      <a-form-item label="半场价格" name="halfPrice">
        <a-input
          allow-clear
          placeholder="请输入半场价格"
          v-model:value="form.halfPrice"
        />
      </a-form-item>
      <a-form-item label="每日不同半场价格" name="halfPrices">
        <a-input
          allow-clear
          placeholder="请输入每日不同半场价格"
          v-model:value="form.halfPrices"
        />
      </a-form-item>
      <a-form-item label="儿童价" name="childrenPrice">
        <a-input
          allow-clear
          placeholder="请输入儿童价"
          v-model:value="form.childrenPrice"
        />
      </a-form-item>
      <a-form-item label="星期选择" name="week">
        <a-input
          allow-clear
          placeholder="请输入星期选择"
          v-model:value="form.week"
        />
      </a-form-item>
      <a-form-item label="排序" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
      <a-form-item label="关联id" name="sid">
        <a-input
          allow-clear
          placeholder="请输入关联id"
          v-model:value="form.sid"
        />
      </a-form-item>
      <a-form-item label="是否关闭，1开启，2关闭" name="isStatus">
        <a-input
          allow-clear
          placeholder="请输入是否关闭，1开启，2关闭"
          v-model:value="form.isStatus"
        />
      </a-form-item>
      <a-form-item label="是否免费：1免费，2收费" name="isFree">
        <a-input
          allow-clear
          placeholder="请输入是否免费：1免费，2收费"
          v-model:value="form.isFree"
        />
      </a-form-item>
      <a-form-item label="开始时间" name="startTime">
        <a-input
          allow-clear
          placeholder="请输入开始时间"
          v-model:value="form.startTime"
        />
      </a-form-item>
      <a-form-item label="" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addBookingPeriod, updateBookingPeriod } from '@/api/booking/bookingPeriod';
  import { BookingPeriod } from '@/api/booking/bookingPeriod/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: BookingPeriod | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<BookingPeriod>({
    id: undefined,
    timePeriod: undefined,
    price: undefined,
    prices: undefined,
    halfPrice: undefined,
    halfPrices: undefined,
    childrenPrice: undefined,
    week: undefined,
    sortNumber: undefined,
    sid: undefined,
    isStatus: undefined,
    isFree: undefined,
    startTime: undefined,
    createTime: undefined,
    updateTime: undefined,
    tenantId: undefined,
    bookingPeriodId: undefined,
    bookingPeriodName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    bookingPeriodName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateBookingPeriod : addBookingPeriod;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
